/* Problem URL: https://codeforces.com/contest/2123/problem/E */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;

        vi a(n);
        cin >> a;
        
        vi count(n + 2);
        rep(i, n) {
            count[a[i]]++;
        }

        vi pref(n + 3);
        pref[0] = count[0] - 1;

        vi suf(n + 3);
        suf[n] = count[n];

        nrep(i, 1, n + 1) {
            pref[i] = pref[i - 1] + count[i] - 1;
            suf[n - i] = suf[n - i + 1] + count[n - i];
        }

        int first = 0;
        while (count[first] > 0) {
            first++;
        }

        vi ans(n + 1);

        for (int i = first; i >= 0; i--) {
            int low = count[i];
            int high = pref[i] + 2 + suf[i + 1];

            ans[low]++;
            if (high > n) {
                continue;
            }

            ans[high]--;
        }

        cout << "1";
        nrep(i, 1, n + 1) {
            ans[i] += ans[i - 1];
            cout << ' ' << ans[i];
        }
        cout << '\n';
    }
}
